import { Monoid } from 'fp-ts/lib/Monoid';
import * as T from 'fp-ts/lib/Task';
import { Observable } from 'rxjs';
import * as O from 'fp-ts/lib/Option';
import * as E from 'fp-ts/lib/Either';
import { Monad1 } from 'fp-ts/lib/Monad';
import * as TE from 'fp-ts/lib/TaskEither';
declare module 'fp-ts/lib/HKT' {
    interface URItoKind<A> {
        'effe-ts/Cmd': Cmd<A>;
    }
}
export declare const URI = "effe-ts/Cmd";
export declare type URI = typeof URI;
export interface Cmd<Action> extends Observable<T.Task<O.Option<Action>>> {
}
export declare const none: Cmd<never>;
export declare const constNone: <Action>() => Cmd<Action>;
export declare const of: <Action>(a: Action) => Observable<T.Task<O.Option<Action>>>;
export declare function getMonoid<A>(): Monoid<Cmd<A>>;
export declare function perform<A, Action>(task: T.Task<A>, f: (a: A) => Action): Cmd<Action>;
export declare function perform_<A, Action>(task: T.Task<A>): Cmd<Action>;
export declare function attempt<L, A, Action>(task: TE.TaskEither<L, A>, f: (e: E.Either<L, A>) => Action): Cmd<Action>;
export declare const cmd: Monad1<URI>;
declare const ap: <A>(fa: Cmd<A>) => <B>(fab: Cmd<(a: A) => B>) => Cmd<B>, apFirst: <B>(fb: Cmd<B>) => <A>(fa: Cmd<A>) => Cmd<A>, apSecond: <B>(fb: Cmd<B>) => <A>(fa: Cmd<A>) => Cmd<B>, chain: <A, B>(f: (a: A) => Cmd<B>) => (ma: Cmd<A>) => Cmd<B>, chainFirst: <A, B>(f: (a: A) => Cmd<B>) => (ma: Cmd<A>) => Cmd<A>, flatten: <A>(mma: Cmd<Cmd<A>>) => Cmd<A>, map: <A, B>(f: (a: A) => B) => (fa: Cmd<A>) => Cmd<B>;
export { ap, apFirst, apSecond, chain, chainFirst, flatten, map };
