import { Monoid } from 'fp-ts/lib/Monoid';
import * as E from 'fp-ts/lib/Either';
import { Monad2 } from 'fp-ts/lib/Monad';
import * as Rr from 'fp-ts/lib/Reader';
import * as RTE from 'fp-ts/lib/ReaderTaskEither';
import * as RT from 'fp-ts/lib/ReaderTask';
import * as cmd from './Cmd';
declare module 'fp-ts/lib/HKT' {
    interface URItoKind2<E, A> {
        'effe-ts/CmdR': CmdR<E, A>;
    }
}
export declare const URI = "effe-ts/CmdR";
export declare type URI = typeof URI;
export interface CmdR<R, Action> extends Rr.Reader<R, cmd.Cmd<Action>> {
}
export declare const ask: <R>() => CmdR<R, R>;
export declare const asks: <R, Action>(f: (env: R) => Action) => CmdR<R, Action>;
export declare const env: <R, Action>(f: (env: R) => CmdR<R, Action>) => CmdR<R, Action>;
export declare const none: CmdR<{}, never>;
export declare const of: <Action>(a: Action) => CmdR<{}, Action>;
export declare function getMonoid<R, Action>(): Monoid<CmdR<R, Action>>;
export declare function perform<R, A, Action>(task: RT.ReaderTask<R, A>, f: (a: A) => Action): CmdR<R, Action>;
export declare function perform_<R, A, Action>(task: RT.ReaderTask<R, A>): CmdR<R, Action>;
export declare function attempt<R, E, A, Action>(task: RTE.ReaderTaskEither<R, E, A>, f: (e: E.Either<E, A>) => Action): CmdR<R, Action>;
export declare function fromCmd<R, Action>(cmd: cmd.Cmd<Action>): CmdR<R, Action>;
export declare const cmdr: Monad2<URI>;
declare const ap: <E, A>(fa: CmdR<E, A>) => <B>(fab: CmdR<E, (a: A) => B>) => CmdR<E, B>, apFirst: <E, B>(fb: CmdR<E, B>) => <A>(fa: CmdR<E, A>) => CmdR<E, A>, apSecond: <E, B>(fb: CmdR<E, B>) => <A>(fa: CmdR<E, A>) => CmdR<E, B>, chain: <E, A, B>(f: (a: A) => CmdR<E, B>) => (ma: CmdR<E, A>) => CmdR<E, B>, chainFirst: <E, A, B>(f: (a: A) => CmdR<E, B>) => (ma: CmdR<E, A>) => CmdR<E, A>, flatten: <E, A>(mma: CmdR<E, CmdR<E, A>>) => CmdR<E, A>, map: <A, B>(f: (a: A) => B) => <E>(fa: CmdR<E, A>) => CmdR<E, B>;
export { ap, apFirst, apSecond, chain, chainFirst, flatten, map };
