import { Observable } from 'rxjs';
import { Reader } from 'fp-ts/lib/Reader';
import * as subr from './SubR';
import * as platform from './Platform';
import * as stater from './StateR';
import * as state from './State';
import * as sub from './Sub';
export interface Html<DOM, Action> {
    (dispatch: platform.Dispatch<Action>): DOM;
}
export interface Renderer<DOM> {
    (dom: DOM): void;
}
export declare function map<DOM, A, Action>(ha: Html<DOM, A>, f: (a: A) => Action): Html<DOM, Action>;
export interface Program<Model, Action, DOM> extends platform.Program<Model, Action> {
    html$: Observable<Html<DOM, Action>>;
}
export interface ProgramR<Env, Model, Action, DOM> extends Reader<Env, Program<Model, Action, DOM>> {
}
export declare function programR<Env, Model, Action, DOM>(init: Reader<Env, stater.StateR<Env, Model, Action>>, update: (action: Action, model: Model) => stater.StateR<Env, Model, Action>, view: (model: Model) => Html<DOM, Action>, subscriptions?: subr.SubR<Env, Model, Action>): ProgramR<Env, Model, Action, DOM>;
export declare function program<Model, Action, DOM>(init: state.State<Model, Action>, update: (action: Action, model: Model) => state.State<Model, Action>, view: (model: Model) => Html<DOM, Action>, subscriptions?: sub.Sub<Model, Action>): ProgramR<{}, Model, Action, DOM>;
export declare function run<Env, Model, Action, DOM>(program: ProgramR<Env, Model, Action, DOM>, renderer: Renderer<DOM>, env: Env): Observable<Model>;
