"use strict";
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (Object.hasOwnProperty.call(mod, k)) result[k] = mod[k];
    result["default"] = mod;
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
const pipeable_1 = require("fp-ts/lib/pipeable");
const Rx = __importStar(require("rxjs/operators"));
const subr = __importStar(require("./SubR"));
const platform = __importStar(require("./Platform"));
const stater = __importStar(require("./StateR"));
const sub = __importStar(require("./Sub"));
function map(ha, f) {
    return dispatch => ha(a => dispatch(f(a)));
}
exports.map = map;
function programR(init, update, view, subscriptions = subr.none) {
    return env => {
        const { dispatch, cmd$, sub$, model$ } = platform.programR(init, update, subscriptions)(env);
        const html$ = pipeable_1.pipe(model$, Rx.map(model => view(model)));
        return { dispatch, cmd$, sub$, model$, html$ };
    };
}
exports.programR = programR;
function program(init, update, view, subscriptions = sub.none) {
    return programR(() => stater.fromState(init), (action, model) => stater.fromState(update(action, model)), view, subr.fromSub(subscriptions));
}
exports.program = program;
function run(program, renderer, env) {
    const p = program(env);
    p.html$.subscribe(html => renderer(html(p.dispatch)));
    return platform.run(() => p, env);
}
exports.run = run;
//# sourceMappingURL=Html.js.map