import { Observable } from 'rxjs';
import * as O from 'fp-ts/lib/Option';
import * as T from 'fp-ts/lib/Task';
import * as IO from 'fp-ts/lib/IO';
import { Reader } from 'fp-ts/lib/Reader';
import { Location as HistoryLocation, History } from 'history';
import { CmdR } from './CmdR';
import * as subr from './SubR';
import * as html from './Html';
import { StateR } from './StateR';
export interface Location extends HistoryLocation {
}
export interface NavigationHistory {
    location: Location;
    push(url: string): IO.IO<void>;
    listen(f: (location: Location) => void): IO.IO<void>;
}
export declare function history(history: History): NavigationHistory;
export interface NavigationEnv {
    history: NavigationHistory;
}
export declare const pushTask: <Env extends NavigationEnv>(url: string) => Reader<Env, T.Task<O.Option<never>>>;
export declare const push: <Env extends NavigationEnv>(url: string) => CmdR<Env, never>;
export interface Program<Model, Action, DOM> extends html.Program<Model, Action, DOM> {
    listen: IO.IO<void>;
}
export interface ProgramR<Env, Model, Action, DOM> extends Reader<Env, Program<Model, Action, DOM>> {
}
export declare function program<Env extends NavigationEnv, Model, Action, DOM>(locationToMessage: (location: Location) => Action, init: (location: Location) => Reader<Env, StateR<Env, Model, Action>>, update: (action: Action, model: Model) => StateR<Env, Model, Action>, view: (model: Model) => html.Html<DOM, Action>, subscriptions?: subr.SubR<Env, Model, Action>): ProgramR<Env, Model, Action, DOM>;
export declare function run<Env extends NavigationEnv, Model, Action, DOM>(program: ProgramR<Env, Model, Action, DOM>, renderer: html.Renderer<DOM>, env: Env): Observable<Model>;
