"use strict";
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (Object.hasOwnProperty.call(mod, k)) result[k] = mod[k];
    result["default"] = mod;
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
const rxjs_1 = require("rxjs");
const O = __importStar(require("fp-ts/lib/Option"));
const pipeable_1 = require("fp-ts/lib/pipeable");
const Rx = __importStar(require("rxjs/operators"));
const T = __importStar(require("fp-ts/lib/Task"));
const CmdR_1 = require("./CmdR");
const subr = __importStar(require("./SubR"));
const html = __importStar(require("./Html"));
function history(history) {
    return {
        location: history.location,
        push: url => () => history.push(url),
        listen: f => () => history.listen(f)
    };
}
exports.history = history;
exports.pushTask = (url) => env => pipeable_1.pipe(T.fromIO(env.history.push(url)), T.map(() => O.none));
exports.push = (url) => CmdR_1.perform_(exports.pushTask(url));
function program(locationToMessage, init, update, view, subscriptions = subr.none) {
    const monoidSubR = subr.getMonoid();
    return env => {
        const location$ = new rxjs_1.Subject();
        const onChangeLocation = subr.fromObservable(pipeable_1.pipe(location$, Rx.map(location => locationToMessage(location))));
        const subs = monoidSubR.concat(subscriptions, onChangeLocation);
        return Object.assign(Object.assign({}, html.programR(init(env.history.location), update, view, subs)(env)), { listen: env.history.listen(location => location$.next(location)) });
    };
}
exports.program = program;
function run(program, renderer, env) {
    const p = program(env);
    p.listen();
    return html.run(() => p, renderer, env);
}
exports.run = run;
//# sourceMappingURL=Navigation.js.map