import * as O from 'fp-ts/lib/Option';
import { Observable } from 'rxjs';
import { Task } from 'fp-ts/lib/Task';
import { Reader } from 'fp-ts/lib/Reader';
import * as subr from './SubR';
import * as stater from './StateR';
import { State } from './State';
import * as sub from './Sub';
export interface Dispatch<Action> {
    (action: Action): void;
}
export interface Program<Model, Action> {
    dispatch: Dispatch<Action>;
    cmd$: Observable<Task<O.Option<Action>>>;
    model$: Observable<Model>;
    sub$: Observable<Action>;
}
export interface ProgramR<Env, Model, Action> extends Reader<Env, Program<Model, Action>> {
}
export declare function programR<Env, Model, Action>(init: Reader<Env, stater.StateR<Env, Model, Action>>, update: (action: Action, model: Model) => stater.StateR<Env, Model, Action>, subscriptions?: subr.SubR<Env, Model, Action>): ProgramR<Env, Model, Action>;
export declare function program<Model, Action>(init: State<Model, Action>, update: (action: Action, model: Model) => State<Model, Action>, subscriptions?: sub.Sub<Model, Action>): ProgramR<{}, Model, Action>;
export declare function run<Env, Model, Action>(program: ProgramR<Env, Model, Action>, env: Env): Observable<Model>;
