"use strict";
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (Object.hasOwnProperty.call(mod, k)) result[k] = mod[k];
    result["default"] = mod;
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
const O = __importStar(require("fp-ts/lib/Option"));
const pipeable_1 = require("fp-ts/lib/pipeable");
const rxjs_1 = require("rxjs");
const operators_1 = require("rxjs/operators");
const T = __importStar(require("fp-ts/lib/Tuple"));
const subr = __importStar(require("./SubR"));
const stater = __importStar(require("./StateR"));
const sub = __importStar(require("./Sub"));
function programR(init, update, subscriptions = subr.none) {
    return env => {
        const state$ = new rxjs_1.BehaviorSubject(init(env));
        const dispatch = action => state$.next(update(action, T.fst(state$.value)));
        const model$ = pipeable_1.pipe(state$, operators_1.map(T.fst), operators_1.distinctUntilChanged(), operators_1.share());
        const cmd$ = pipeable_1.pipe(state$, operators_1.map(state => T.snd(state)(env)), operators_1.mergeAll());
        const sub$ = subscriptions(env)(model$);
        return { cmd$, dispatch, model$, sub$ };
    };
}
exports.programR = programR;
function program(init, update, subscriptions = sub.none) {
    return programR(() => stater.fromState(init), (action, model) => stater.fromState(update(action, model)), subr.fromSub(subscriptions));
}
exports.program = program;
function run(program, env) {
    const { dispatch, cmd$, model$, sub$ } = program(env);
    sub$.subscribe(dispatch);
    cmd$.subscribe(cmd => cmd().then(O.map(dispatch)));
    return model$;
}
exports.run = run;
//# sourceMappingURL=Platform.js.map