import { Bifunctor2 } from 'fp-ts/lib/Bifunctor';
import { Semigroupoid2 } from 'fp-ts/lib/Semigroupoid';
import { Comonad2 } from 'fp-ts/lib/Comonad';
import { Foldable2 } from 'fp-ts/lib/Foldable';
import { Traversable2 } from 'fp-ts/lib/Traversable';
import { Monad2 } from 'fp-ts/lib/Monad';
import { Monoid } from 'fp-ts/lib/Monoid';
import { Semigroup } from 'fp-ts/lib/Semigroup';
import { Cmd } from './Cmd';
declare module 'fp-ts/lib/HKT' {
    interface URItoKind2<E, A> {
        'effe-ts/State': State<A, E>;
    }
}
export declare const URI = "effe-ts/State";
export declare type URI = typeof URI;
export declare type State<Model, Action = never> = [Model, Cmd<Action>];
export declare const model: <Model, Action>(state: State<Model, Action>) => Model;
export declare const cmd: <Model, Action>(state: State<Model, Action>) => Cmd<Action>;
export declare const of: <Model, Action = never>(model: Model) => State<Model, Action>;
export declare function getSemigroup<Model, Action>(S: Semigroup<Model>): Semigroup<State<Model, Action>>;
export declare function getMonoid<Model, Action>(M: Monoid<Model>): Monoid<State<Model, Action>>;
export declare const state: Semigroupoid2<URI> & Bifunctor2<URI> & Comonad2<URI> & Foldable2<URI> & Traversable2<URI> & Monad2<URI>;
declare const ap: <E, A>(fa: State<A, E>) => <B>(fab: State<(a: A) => B, E>) => State<B, E>, apFirst: <E, B>(fb: State<B, E>) => <A>(fa: State<A, E>) => State<A, E>, apSecond: <E, B>(fb: State<B, E>) => <A>(fa: State<A, E>) => State<B, E>, bimap: <E, G, A, B>(f: (e: E) => G, g: (a: A) => B) => (fa: State<A, E>) => State<B, G>, chain: <E, A, B>(f: (a: A) => State<B, E>) => (ma: State<A, E>) => State<B, E>, chainFirst: <E, A, B>(f: (a: A) => State<B, E>) => (ma: State<A, E>) => State<A, E>, compose: <E, A>(la: State<A, E>) => <B>(ab: State<B, A>) => State<B, E>, duplicate: <E, A>(ma: State<A, E>) => State<State<A, E>, E>, extend: <E, A, B>(f: (fa: State<A, E>) => B) => (ma: State<A, E>) => State<B, E>, flatten: <E, A>(mma: State<State<A, E>, E>) => State<A, E>, foldMap: <M>(M: Monoid<M>) => <A>(f: (a: A) => M) => <E>(fa: State<A, E>) => M, map: <A, B>(f: (a: A) => B) => <E>(fa: State<A, E>) => State<B, E>, mapLeft: <E, G>(f: (e: E) => G) => <A>(fa: State<A, E>) => State<A, G>, reduce: <A, B>(b: B, f: (b: B, a: A) => B) => <E>(fa: State<A, E>) => B, reduceRight: <A, B>(b: B, f: (a: A, b: B) => B) => <E>(fa: State<A, E>) => B;
export { ap, apFirst, apSecond, bimap, chain, chainFirst, compose, duplicate, extend, flatten, foldMap, map, mapLeft, reduce, reduceRight };
