import { Semigroupoid3 } from 'fp-ts/lib/Semigroupoid';
import { Bifunctor3 } from 'fp-ts/lib/Bifunctor';
import { Comonad3 } from 'fp-ts/lib/Comonad';
import { Foldable3 } from 'fp-ts/lib/Foldable';
import { Traversable3 } from 'fp-ts/lib/Traversable';
import { Monad3 } from 'fp-ts/lib/Monad';
import { Monoid } from 'fp-ts/lib/Monoid';
import { Semigroup } from 'fp-ts/lib/Semigroup';
import { CmdR } from './CmdR';
import { State } from './State';
declare module 'fp-ts/lib/HKT' {
    interface URItoKind3<R, E, A> {
        'effe-ts/StateR': StateR<R, A, E>;
    }
}
export declare const URI = "effe-ts/StateR";
export declare type URI = typeof URI;
export declare type StateR<R, Model, Action = never> = [Model, CmdR<R, Action>];
export declare const model: <R, Model, Action>(state: StateR<R, Model, Action>) => Model;
export declare const cmdr: <R, Model, Action>(state: StateR<R, Model, Action>) => CmdR<R, Action>;
export declare const of: <R, Model, Action = never>(model: Model) => StateR<R, Model, Action>;
export declare function fromState<Model, Action>([model, cmd]: State<Model, Action>): StateR<{}, Model, Action>;
export declare function getSemigroup<R, Model, Action>(S: Semigroup<Model>): Semigroup<StateR<R, Model, Action>>;
export declare function getMonoid<R, Model, Action>(M: Monoid<Model>): Monoid<StateR<R, Model, Action>>;
export declare const stater: Semigroupoid3<URI> & Bifunctor3<URI> & Comonad3<URI> & Foldable3<URI> & Traversable3<URI> & Monad3<URI>;
declare const ap: <R, E, A>(fa: StateR<R, A, E>) => <B>(fab: StateR<R, (a: A) => B, E>) => StateR<R, B, E>, apFirst: <R, E, B>(fb: StateR<R, B, E>) => <A>(fa: StateR<R, A, E>) => StateR<R, A, E>, apSecond: <R, E, B>(fb: StateR<R, B, E>) => <A>(fa: StateR<R, A, E>) => StateR<R, B, E>, bimap: <E, G, A, B>(f: (e: E) => G, g: (a: A) => B) => <R>(fa: StateR<R, A, E>) => StateR<R, B, G>, chain: <R, E, A, B>(f: (a: A) => StateR<R, B, E>) => (ma: StateR<R, A, E>) => StateR<R, B, E>, chainFirst: <R, E, A, B>(f: (a: A) => StateR<R, B, E>) => (ma: StateR<R, A, E>) => StateR<R, A, E>, compose: <R, E, A>(la: StateR<R, A, E>) => <B>(ab: StateR<R, B, A>) => StateR<R, B, E>, duplicate: <R, E, A>(ma: StateR<R, A, E>) => StateR<R, StateR<R, A, E>, E>, extend: <R, E, A, B>(f: (fa: StateR<R, A, E>) => B) => (ma: StateR<R, A, E>) => StateR<R, B, E>, flatten: <R, E, A>(mma: StateR<R, StateR<R, A, E>, E>) => StateR<R, A, E>, foldMap: <M>(M: Monoid<M>) => <A>(f: (a: A) => M) => <R, E>(fa: StateR<R, A, E>) => M, map: <A, B>(f: (a: A) => B) => <R, E>(fa: StateR<R, A, E>) => StateR<R, B, E>, mapLeft: <E, G>(f: (e: E) => G) => <R, A>(fa: StateR<R, A, E>) => StateR<R, A, G>, reduce: <A, B>(b: B, f: (b: B, a: A) => B) => <R, E>(fa: StateR<R, A, E>) => B, reduceRight: <A, B>(b: B, f: (a: A, b: B) => B) => <R, E>(fa: StateR<R, A, E>) => B;
export { ap, apFirst, apSecond, bimap, chain, chainFirst, compose, duplicate, extend, flatten, foldMap, map, mapLeft, reduce, reduceRight };
