"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const pipeable_1 = require("fp-ts/lib/pipeable");
const CmdR_1 = require("./CmdR");
exports.URI = 'effe-ts/StateR';
exports.model = (state) => state[0];
exports.cmdr = (state) => state[1];
exports.of = (model) => [model, CmdR_1.none];
function fromState([model, cmd]) {
    return [model, CmdR_1.fromCmd(cmd)];
}
exports.fromState = fromState;
const monoidCmd = CmdR_1.getMonoid();
function getSemigroup(S) {
    return {
        concat: (x, y) => [S.concat(exports.model(x), exports.model(y)), monoidCmd.concat(exports.cmdr(x), exports.cmdr(y))]
    };
}
exports.getSemigroup = getSemigroup;
function getMonoid(M) {
    return Object.assign(Object.assign({}, getSemigroup(M)), { empty: exports.of(M.empty) });
}
exports.getMonoid = getMonoid;
exports.stater = {
    URI: exports.URI,
    compose: (ba, ae) => [exports.model(ba), exports.cmdr(ae)],
    map: (ma, f) => [f(ma[0]), ma[1]],
    bimap: (ma, f, g) => [g(exports.model(ma)), CmdR_1.cmdr.map(exports.cmdr(ma), f)],
    mapLeft: (ma, f) => [exports.model(ma), CmdR_1.cmdr.map(exports.cmdr(ma), f)],
    ap: (fab, fa) => [exports.model(fab)(exports.model(fa)), monoidCmd.concat(exports.cmdr(fab), exports.cmdr(fa))],
    of: exports.of,
    chain: (fa, f) => {
        const [b, s] = f(exports.model(fa));
        return [b, monoidCmd.concat(exports.cmdr(fa), s)];
    },
    extract: exports.model,
    extend: (ae, f) => [f(ae), exports.cmdr(ae)],
    reduce: (ae, b, f) => f(b, exports.model(ae)),
    foldMap: _ => (ae, f) => f(exports.model(ae)),
    reduceRight: (ae, b, f) => f(exports.model(ae), b),
    traverse: (F) => (as, f) => {
        return F.map(f(exports.model(as)), b => [b, exports.cmdr(as)]);
    },
    sequence: (F) => (fas) => {
        return F.map(exports.model(fas), a => [a, exports.cmdr(fas)]);
    }
};
const { ap, apFirst, apSecond, bimap, chain, chainFirst, compose, duplicate, extend, flatten, foldMap, map, mapLeft, reduce, reduceRight } = pipeable_1.pipeable(exports.stater);
exports.ap = ap;
exports.apFirst = apFirst;
exports.apSecond = apSecond;
exports.bimap = bimap;
exports.chain = chain;
exports.chainFirst = chainFirst;
exports.compose = compose;
exports.duplicate = duplicate;
exports.extend = extend;
exports.flatten = flatten;
exports.foldMap = foldMap;
exports.map = map;
exports.mapLeft = mapLeft;
exports.reduce = reduce;
exports.reduceRight = reduceRight;
//# sourceMappingURL=StateR.js.map