import { Observable } from 'rxjs';
import * as Rr from 'fp-ts/lib/Reader';
import { Monoid } from 'fp-ts/lib/Monoid';
import { Monad2 } from 'fp-ts/lib/Monad';
import { Profunctor2 } from 'fp-ts/lib/Profunctor';
import { Cmd } from './Cmd';
declare module 'fp-ts/lib/HKT' {
    interface URItoKind2<E, A> {
        'effe-ts/Sub': Sub<E, A>;
    }
}
export declare const URI = "effe-ts/Sub";
export declare type URI = typeof URI;
export interface Sub<Model, Action> extends Rr.Reader<Observable<Model>, Observable<Action>> {
}
export declare function fromObservable<Model, Action>(actions$: Observable<Action>): Sub<Model, Action>;
export declare function fromCmd<Model, Action>(cmd: Cmd<Action>): Sub<Model, Action>;
export declare const none: Sub<unknown, never>;
export declare function getMonoid<Model, Action>(): Monoid<Sub<Model, Action>>;
export declare const sub: Profunctor2<URI> & Monad2<URI>;
declare const ap: <E, A>(fa: Sub<E, A>) => <B>(fab: Sub<E, (a: A) => B>) => Sub<E, B>, apFirst: <E, B>(fb: Sub<E, B>) => <A>(fa: Sub<E, A>) => Sub<E, A>, apSecond: <E, B>(fb: Sub<E, B>) => <A>(fa: Sub<E, A>) => Sub<E, B>, chain: <E, A, B>(f: (a: A) => Sub<E, B>) => (ma: Sub<E, A>) => Sub<E, B>, map: <A, B>(f: (a: A) => B) => <E>(fa: Sub<E, A>) => Sub<E, B>, chainFirst: <E, A, B>(f: (a: A) => Sub<E, B>) => (ma: Sub<E, A>) => Sub<E, A>, flatten: <E, A>(mma: Sub<E, Sub<E, A>>) => Sub<E, A>, promap: <E, A, D, B>(f: (d: D) => E, g: (a: A) => B) => (fbc: Sub<E, A>) => Sub<D, B>;
export { ap, apFirst, apSecond, chain, chainFirst, flatten, map, promap };
