import { Observable } from 'rxjs';
import * as Rr from 'fp-ts/lib/Reader';
import { Monoid } from 'fp-ts/lib/Monoid';
import { Monad3 } from 'fp-ts/lib/Monad';
import { Profunctor3 } from 'fp-ts/lib/Profunctor';
import * as sub from './Sub';
import { Cmd } from './Cmd';
import { CmdR } from './CmdR';
declare module 'fp-ts/lib/HKT' {
    interface URItoKind3<R, E, A> {
        'effe-ts/SubR': SubR<R, E, A>;
    }
}
export declare const URI = "effe-ts/SubR";
export declare type URI = typeof URI;
export interface SubR<R, Model, Action> extends Rr.Reader<R, sub.Sub<Model, Action>> {
}
export declare const none: SubR<{}, unknown, never>;
export declare function fromObservable<R, Model, Action>(actions$: Observable<Action>): SubR<R, Model, Action>;
export declare function fromSub<R, Model, Action>(sub: sub.Sub<Model, Action>): SubR<R, Model, Action>;
export declare function fromCmd<R, Model, Action>(cmd: Cmd<Action>): SubR<R, Model, Action>;
export declare function fromCmdR<R, Model, Action>(cmdr: CmdR<R, Action>): SubR<R, Model, Action>;
export declare function getMonoid<R, Model, Action>(): Monoid<SubR<R, Model, Action>>;
export declare const subr: Profunctor3<URI> & Monad3<URI>;
declare const ap: <R, E, A>(fa: SubR<R, E, A>) => <B>(fab: SubR<R, E, (a: A) => B>) => SubR<R, E, B>, apFirst: <R, E, B>(fb: SubR<R, E, B>) => <A>(fa: SubR<R, E, A>) => SubR<R, E, A>, apSecond: <R, E, B>(fb: SubR<R, E, B>) => <A>(fa: SubR<R, E, A>) => SubR<R, E, B>, chain: <R, E, A, B>(f: (a: A) => SubR<R, E, B>) => (ma: SubR<R, E, A>) => SubR<R, E, B>, map: <A, B>(f: (a: A) => B) => <R, E>(fa: SubR<R, E, A>) => SubR<R, E, B>, chainFirst: <R, E, A, B>(f: (a: A) => SubR<R, E, B>) => (ma: SubR<R, E, A>) => SubR<R, E, A>, flatten: <R, E, A>(mma: SubR<R, E, SubR<R, E, A>>) => SubR<R, E, A>, promap: <R, E, A, D, B>(f: (d: D) => E, g: (a: A) => B) => (fbc: SubR<R, E, A>) => SubR<R, D, B>;
export { ap, apFirst, apSecond, chain, chainFirst, flatten, map, promap };
